Subject: Re: bug#67661: 30.0.50; *Completions* has started popping up for icomplete-in-buffer

From: Eli Zaretskii <[email-masked]>
Date: Sat, 30 Dec 2023 08:30:29 +0200

> From: Sean Whitton <[email-masked]>
> Cc: [email-masked], [email-masked]
> Date: Fri, 29 Dec 2023 20:24:26 +0000
> 
> On Fri 29 Dec 2023 at 09:27pm +02, Eli Zaretskii wrote:
> 
> > To which entry in Emacs 29's NEWS would this be related?
> 
> I'm talking about how Juri fixed icomplete-in-buffer for Emacs 29, and
> how it's now working differently.  Juri's fix wasn't noted in NEWS.29,
> so there isn't a relevant entry.

I thought you were suggesting to add something to NEWS in Emacs 29.
If there's no suitable entry there, then I wonder what did you have in
mind for Emacs 29 in this area.

> Thus, I propose adding a NEWS.30 entry like this:
> 
>     There have been some changes which normalise some behaviour of
>     in-buffer completion that affect users of icomplete-in-buffer.
> 
>     Firstly, completion-auto-help now governs icomplete-in-buffer,
>     whereas previously it affected only minibuffer completion.  You may
>     wish to review any existing customisation for completion-auto-help
>     if in-buffer completion behaves in a way that surprises you.
> 
>     Secondly, the *Completions* buffer now always pops up at the same
>     time that Icomplete displays its in-buffer completion.  If you would
>     prefer to see only Icomplete's display, which is what you might be
>     used to, you could use
> 
>         (advice-add 'completion-at-point :after #'minibuffer-hide-completions)

AFAIU, this should also mention changes in Emacs 29 wrt previous
versions.

Also, the entry should in terms of user-facing behavior, not in terms
of how code works.  It should also be more concrete; phrases like "you
may wish to review existing customizations" are too vague to be
useful.

The last paragraph seems to indicate we lack some user option or a
variable to get back the old behavior, since using advice-add is less
friendly than flipping a variable.

(IMO, we are making too many backward-incompatible changes in this
area lately.  But that's me.)